DECLARE SUB makeytable ()
DECLARE SUB Bump (lightbx%, lightby%)
DECLARE SUB testlight ()
DECLARE SUB ComputeLight ()
DECLARE SUB GetPal (pal() AS INTEGER)
DECLARE SUB ComputeLUT (pal%(), lut%())
DECLARE FUNCTION ClosestColor% (pal%(), r%, g%, b%)
DECLARE SUB ReadGif (filename$)
'************************************************************
'BUMPY.BAS 07-03-00 19:24
'QB Version Copyright 2000 Toshi Horie
' > You can load QB using QB/AH if you run out of memory
'      or get "Subscript out of range error"
' > Please run this program compiled, unless you understand
'    my comments and know how to make it run in the IDE.
' > The program caches the color optimizations on disk, so it will
'   run faster the second time you run it on a particular
'   colormap file.
' > runs at 26 fps on a Pentium 100 with 82 lines shown.
'uses DEGIF6.BAS by Rich Geldreich 1993 (Public domain)
'port of BUMP.C by Alex J. Champandard 1999 (Public domain)
'************************************************************
DEFINT A-Z
CONST lutfile$ = "COLORLUT.DAT"
CONST compiled = 1
CONST lightsize = 3.4

CONST XMAX = 319
CONST YMIN = 60
CONST YMIN1 = YMIN + 1
CONST YMAX = 142

'$DYNAMIC
DIM SHARED BumpMap(0 TO XMAX, YMIN TO YMAX)
DIM SHARED colormap(0 TO XMAX, YMIN TO YMAX)
DIM SHARED lut(127, 255)
'$STATIC
DIM SHARED light(-63 TO 63, -63 TO 63)
DIM SHARED pal(768)
'IF compiled THEN
    DIM SHARED ytab(199)
    CALL makeytable
'END IF
CALL ReadGif("bump.gif")
COLOR 7: LOCATE 25, 1: PRINT "Computing lightmap...";
CALL ComputeLight
'CALL testlight
CALL ReadGif("map.gif")
CALL GetPal(pal())
COLOR 7: LOCATE 25, 1: PRINT "Computing optimal colors...";
CALL ComputeLUT(pal(), lut())
LOCATE 25, 1: PRINT "computing color LUT... Finished!";
CLS
frames& = 0
DEF SEG = &HA000
t1! = TIMER
DO
    t! = TIMER
    lightbx = INT(COS(t! * .6) * COS(t!) * 160 + 98)
    lightby = INT(SIN(t! + .4) * 65 + 112)
    CALL Bump(lightbx, lightby)
    frames& = (frames& + 1)
LOOP UNTIL lightbx = -9999
PALETTE
CLS
COLOR 15
PRINT "BUMPY - by Toshi Horie, Rich Geldreich, and Alex Champandard"
COLOR 7
elapsed! = (t! - t1!)
IF elapsed! > .1 THEN
PRINT USING "##.## fps"; frames& / elapsed!
END IF
k$ = INPUT$(1)
END

SUB Bump (lightbx, lightby)
'must have DEF SEG=&HA000 before calling this!
'IF compiled THEN
    pp = ytab(lightby) + lightbx
    POKE pp - 1, 7: POKE pp, 7: POKE pp + 1, 7
    POKE pp - 320, 7: POKE pp + 320, 7
'ELSE
'    PSET (lightbx, lightby - 1), 7
'    PSET (lightbx, lightby), 7
'    PSET (lightbx, lightby + 1), 7
'    PSET (lightbx - 1, lightby), 7
'    PSET (lightbx + 1, lightby), 7
'endif
FOR j = YMIN1 TO YMAX
    IF INKEY$ > "" THEN lightbx = -9999: EXIT SUB
    FOR i = 1 TO XMAX
        'calculate coordinates of the pixel we need in light map
        'given the slope at this point, and the zoom coefficient
        px = i + BumpMap(i - 1, j) - BumpMap(i, j)
        py = j + BumpMap(i, j - 1) - BumpMap(i, j)
       
        'add movement of SECOND light
        x = (px - lightbx)
        y = (py - lightby)

        'check if the coordinates are inside the light buffer
        'COLOR 7: LOCATE 25, 1: PRINT "x="; x; "y="; y;
        c = 0
        IF (y >= -63) AND (y <= 63) AND (x >= -63) AND (x <= 63) THEN
            'if so, get the pixel
            c = light(x, y)
            IF c > 254 THEN c = 254
        END IF
        'IF compiled THEN
            POKE (ytab(j) + i), lut(c \ 2, colormap(i, j))
        'ELSE
        '    PSET (i, j), lut(c \ 2, colormap(i, j))
        'END IF
    NEXT
NEXT
IF lightby >= YMAX OR lightby <= YMIN1 OR lightbx < 2 THEN
    'IF compiled THEN
        POKE pp - 1, 0: POKE pp, 0: POKE pp + 1, 0
        POKE pp - 320, 0: POKE pp + 320, 0
    'ELSE
    '    PSET (lightbx, lightby - 1), 0
    '    PSET (lightbx, lightby), 0
    '    PSET (lightbx, lightby + 1), 0
    '    PSET (lightbx - 1, lightby), 0
    '    PSET (lightbx + 1, lightby), 0
    'endif
END IF
END SUB

FUNCTION ClosestColor (pal(), r, g, b)
dist = 32767
FOR i = 0 TO 255
    i3 = i * 3
    newDist = (r - pal(i3)) * (r - pal(i3)) + (g - pal(i3 + 1)) * (g - pal(i3 + 1)) + (b - pal(i3 + 2)) * (b - pal(i3 + 2))
    IF newDist = 0 THEN ClosestColor = i: EXIT FUNCTION
    IF (newDist < dist) THEN
        index = i
        dist = newDist
    END IF
NEXT
ClosestColor = index
END FUNCTION

' generate a spot light pattern
SUB ComputeLight
    FOR j = -63 TO 63
        FOR i = -63 TO 63
            dist! = i * i + j * j
            IF ABS(dist!) > 1 THEN dist! = SQR(dist!)
            'fade according to distance and random coefficient
            c = INT(lightsize * dist! + RND * 7.1) - 3
            ' clip to range [0 to 255]
            IF c < 0 THEN
                c = 0
            ELSEIF c > 255 THEN
                c = 255
            END IF
            light(i, j) = 255 - c
        NEXT
    NEXT
END SUB

SUB ComputeLUT (pal(), lut()) STATIC
OPEN lutfile$ FOR BINARY AS #1
IF LOF(1) > 0 THEN
    'if lookup table is saved on disk, load it
    'because it's faster than the O(n^3) algo below
    CLOSE #1
    DEF SEG = VARSEG(lut(0, 0))
    BLOAD lutfile$, 0
    DEF SEG
ELSE
    CLOSE #1
    KILL lutfile$
    'for each color
    FOR j = 0 TO 255
       PSET (j, 170), j
       r = pal(j * 3)
       g = pal(j * 3 + 1)
       b = pal(j * 3 + 2)
       'for 128 intensity levels
       FOR i = 0 TO 254 STEP 2
          lut(i \ 2, j) = ClosestColor(pal(), (r * i) \ 254, (g * i) \ 254, (b * i) \ 254)
       NEXT
    NEXT
    DEF SEG = VARSEG(lut(0, 0))
    BSAVE lutfile$, 0, 65535
    DEF SEG
END IF

END SUB

' gets the current 256 color VGA palette
SUB GetPal (pal() AS INTEGER)
    OUT &H3C7, 0
    i = 0
    DO
        pal(i) = INP(&H3C9): i = i + 1
        pal(i) = INP(&H3C9): i = i + 1
        pal(i) = INP(&H3C9): i = i + 1
    LOOP UNTIL i = 768
END SUB

SUB makeytable
FOR i = 0 TO 199
ytab(i) = i * 320
NEXT i
END SUB

SUB ReadGif (a$)
IF a$ = "bump.gif" THEN maptype = 1
IF a$ = "map.gif" THEN maptype = 2
'Prefix() and Suffix() hold the LZW phrase dictionary.
'OutStack() is used as a decoding stack.
'ShiftOut() as a power of two table used to quickly retrieve the LZW
'multibit codes.
DIM Prefix(4095), Suffix(4095), OutStack(4095), ShiftOut(8)

'stupid QB compiler doesn't do flow analysis,
'so we either have to have two SUBs (one for compiled, one for not)
'or we just comment things out
'IF compiled THEN
    DIM YBase AS INTEGER, Powersof2(11) AS INTEGER, WorkCode AS INTEGER
'ELSE
'    DIM YBase AS LONG, Powersof2(11) AS LONG, WorkCode AS LONG
'END IF
'Precalculate power of two tables for fast shifts.
FOR a = 0 TO 8: ShiftOut(8 - a) = 2 ^ a: NEXT
FOR a = 0 TO 11: Powersof2(a) = 2 ^ a: NEXT

'Open file for input so QB stops with an error if it doesn't exist.
OPEN a$ FOR INPUT AS #1: CLOSE #1
OPEN a$ FOR BINARY AS #1

'Check to see if GIF file. Ignore GIF version number.
a$ = "      ": GET #1, , a$
IF LEFT$(a$, 3) <> "GIF" THEN PRINT "Not a GIF file.": END

'Get logical screen's X and Y resolution.
GET #1, , TotalX: GET #1, , TotalY: GOSUB GetByte
'Calculate number of colors and find out if a global palette exists.
NumColors = 2 ^ ((a AND 7) + 1): NoPalette = (a AND 128) = 0
'Retrieve background color.
GOSUB GetByte: Background = a

'Get aspect ratio and ignore it.
GOSUB GetByte

'Retrieve global palette if it exists.
IF NoPalette = 0 THEN P$ = SPACE$(NumColors * 3): GET #1, , P$

DO 'Image decode loop

'Skip by any GIF extensions.
'(With a few modifications this code could also fetch comments.)
DO
    'Skip by any zeros at end of image (why must I do this? the
    'GIF spec never mentioned it)
    DO
        IF EOF(1) THEN GOTO AllDone 'if at end of file, exit
        GOSUB GetByte
    LOOP WHILE a = 0           'loop while byte fetched is zero

    SELECT CASE a
    CASE 44  'We've found an image descriptor!
        EXIT DO
    CASE 59  'GIF trailer, stop decoding.
        GOTO AllDone
    CASE IS <> 33
        PRINT "Unknown GIF extension type.": END
    CASE ELSE
        ' do nothing
    END SELECT
    'Skip by blocked extension data.
    GOSUB GetByte
    DO: GOSUB GetByte: a$ = SPACE$(a): GET #1, , a$: LOOP UNTIL a = 0
LOOP
'Get image's start coordinates and size.
GET #1, , XStart: GET #1, , YStart: GET #1, , XLength: GET #1, , YLength
XEnd = XStart + XLength: YEnd = YStart + YLength

'Check for local colormap, and fetch it if it exists.
GOSUB GetByte
IF (a AND 128) THEN
    NoPalette = 0
    NumColors = 2 ^ ((a AND 7) + 1)
    P$ = SPACE$(NumColors * 3): GET #1, , P$
END IF

'Check for interlaced image.
Interlaced = (a AND 64) > 0: PassNumber = 0: PassStep = 8

'Get LZW starting code size.
GOSUB GetByte

'Calculate clear code, end of stream code, and first free LZW code.
ClearCode = 2 ^ a
EOSCode = ClearCode + 1
FirstCode = ClearCode + 2: NextCode = FirstCode
StartCodeSize = a + 1: CodeSize = StartCodeSize

'Find maximum code for the current code size.
StartMaxCode = 2 ^ (a + 1) - 1: MaxCode = StartMaxCode

BitsIn = 0: BlockSize = 0: BlockPointer = 1

x = XStart: y = YStart: YBase = y * 320&

'Set screen 13 in not set yet.
IF FirstTime = 0 THEN
    'Go to VGA mode 13 (320x200x256).
    SCREEN 13: DEF SEG = &HA000
END IF

'Set palette, if there was one.
IF NoPalette = 0 THEN
    'Use OUTs for speed.
    OUT &H3C8, 0
    FOR a = 1 TO NumColors * 3: OUT &H3C9, ASC(MID$(P$, a, 1)) \ 4: NEXT
    'Save palette of image to disk.
    'OPEN "pal." FOR BINARY AS #2: PUT #2, , P$: CLOSE #2
END IF

IF FirstTime = 0 THEN
  'Clear entire screen to background color. This isn't
  'done until the image's palette is set, to avoid flicker
  'on some GIFs.
    LINE (0, 0)-(319, 199), Background, BF
    FirstTime = -1
END IF

'Decode LZW data stream to screen.
DO
    'Retrieve one LZW code.
    GOSUB GetCode
    'Is it an end of stream code?
    IF Code <> EOSCode THEN
        'Is it a clear code? (The clear code resets the sliding
        'dictionary - it *should* be the first LZW code present in
        'the data stream.)
        IF Code = ClearCode THEN
            NextCode = FirstCode
            CodeSize = StartCodeSize
            MaxCode = StartMaxCode
            DO: GOSUB GetCode: LOOP WHILE Code = ClearCode
            IF Code = EOSCode THEN GOTO ImageDone
            LastCode = Code: LastPixel = Code
            IF x <= XMAX AND y >= YMIN AND y <= YMAX THEN
                POKE x + YBase, LastPixel
                IF maptype = 1 THEN
                    BumpMap(x, y) = LastPixel
                ELSEIF maptype = 2 THEN
                    colormap(x, y) = LastPixel
                END IF
            END IF
            x = x + 1: IF x = XEnd THEN GOSUB NextScanLine
        ELSE
            CurCode = Code: StackPointer = 0

            'Have we entered this code into the dictionary yet?
            IF Code >= NextCode THEN
                IF Code > NextCode THEN GOTO AllDone 'Bad GIF if this happens.
               'mimick last code if we haven't entered the requested
               'code into the dictionary yet
                CurCode = LastCode
                OutStack(StackPointer) = LastPixel
                StackPointer = StackPointer + 1
            END IF

            'Recursively get each character of the string.
            'Since we get the characters in reverse, "push" them
            'onto a stack so we can "pop" them off later.
            'Hint: There is another, much faster way to accomplish
            'this that doesn't involve a decoding stack at all...
            DO WHILE CurCode >= FirstCode
                OutStack(StackPointer) = Suffix(CurCode)
                StackPointer = StackPointer + 1
                CurCode = Prefix(CurCode)
            LOOP

            LastPixel = CurCode
            IF x <= XMAX AND y >= YMIN AND y <= YMAX THEN
                POKE x + YBase, LastPixel
                IF maptype = 1 THEN
                    BumpMap(x, y) = LastPixel
                ELSEIF maptype = 2 THEN
                    colormap(x, y) = LastPixel
                END IF
            END IF
            x = x + 1: IF x = XEnd THEN GOSUB NextScanLine

            '"Pop" each character onto the display.
            FOR a = StackPointer - 1 TO 0 STEP -1
                IF x <= XMAX AND y >= YMIN AND y <= YMAX THEN
                    POKE x + YBase, OutStack(a)
                    IF maptype = 1 THEN
                        BumpMap(x, y) = OutStack(a)
                    ELSEIF maptype = 2 THEN
                        colormap(x, y) = OutStack(a)
                    END IF
                END IF
                x = x + 1: IF x = XEnd THEN GOSUB NextScanLine
            NEXT

            'Can we put this new string into our dictionary? (Some GIF
            'encoders will wait a bit when the dictionary is full
            'before sending a clear code- this increases compression
            'because the dictionary's contents are thrown away less
            'often.)
            IF NextCode < 4096 THEN
                'Store new string in the dictionary for later use.
                Prefix(NextCode) = LastCode
                Suffix(NextCode) = LastPixel
                NextCode = NextCode + 1
                'Time to increase the LZW code size?
                IF (NextCode > MaxCode) AND (CodeSize < 12) THEN
                    CodeSize = CodeSize + 1
                    MaxCode = MaxCode * 2 + 1
                END IF
            END IF
            LastCode = Code
        END IF
    END IF
LOOP UNTIL Code = EOSCode
ImageDone:

LOOP

AllDone:

'Save image and palette to BSAVE file.
'DEF SEG = &HA000
'OUT &H3C7, 0
'FOR a = 0 TO 767
'    POKE a + 64000, INP(&H3C9)
'NEXT
'BSAVE "pic.bas", 0, 64768

'Load images saved with the above code with this:
'DEF SEG= &HA000
'BLOAD "Pic.Bas"
'OUT &H3C8, 0
'FOR a = 0 To 767
'     OUT &H3C9, Peek(a+ 64000)
'NEXT
CLOSE #1
ERASE Prefix
ERASE Suffix
ERASE OutStack
ERASE ShiftOut
ERASE Powersof2
EXIT SUB



'Slowly reads one byte from the GIF file...
GetByte: a$ = " ": GET #1, , a$: a = ASC(a$): RETURN

'Moves down one scanline. If the GIF is interlaced, then the number
'of scanlines skipped is based on the current pass.
NextScanLine:
    IF Interlaced THEN
        y = y + PassStep
        IF y >= YEnd THEN
            PassNumber = PassNumber + 1
            SELECT CASE PassNumber
            CASE 1: y = 4: PassStep = 8
            CASE 2: y = 2: PassStep = 4
            CASE 3: y = 1: PassStep = 2
            END SELECT
        END IF
    ELSE
        y = y + 1
    END IF
    x = XStart: YBase = y * 320&
RETURN

'Reads a multibit code from the data stream.
GetCode:
    WorkCode = LastChar \ ShiftOut(BitsIn)
  'Loop while more bits are needed.
    DO WHILE CodeSize > BitsIn
'Reads a byte from the LZW data stream. Since the data stream is
'blocked, a check is performed for the end of the current block
'before each byte is fetched.
        IF BlockPointer > BlockSize THEN
          'Retrieve block's length
            GOSUB GetByte: BlockSize = a
            a$ = SPACE$(BlockSize): GET #1, , a$
            BlockPointer = 1
        END IF
      'Yuck, ASC() and MID$() aren't that fast.
        LastChar = ASC(MID$(a$, BlockPointer, 1))
        BlockPointer = BlockPointer + 1
      'Append 8 more bits to the input buffer
        WorkCode = WorkCode OR LastChar * Powersof2(BitsIn)
        BitsIn = BitsIn + 8
    LOOP
  'Take away x number of bits.
    BitsIn = BitsIn - CodeSize
  'Return code to caller.
    Code = WorkCode AND MaxCode
RETURN
END SUB

SUB testlight
FOR i = -63 TO 63
FOR j = -63 TO 63
PSET (i + 64, j + 64), light(i, j)
NEXT j, i
COLOR 7: LOCATE 25, 1: PRINT "press any key to continue";
k$ = INPUT$(1)
END SUB

